#include "league.hpp"
#include "meeting_generator.hpp"

void League::add(const Team& team)
{
    teams_.add(team);
}

void League::add(const Meeting& meeting)
{
    meetings_.add(meeting);
}

Ranking League::getRanking()
{
    return Ranking(getAllMeetings());
}

Meetings League::getPlayedMeetings()
{
    return meetings_;
}

Meetings League::generateAllMeetings()
{
    return MeetingGenerator().generate(teams_);
}

Meetings League::getMeetingsToPlay()
{
    auto meetings = generateAllMeetings();

    for (auto& meeting : meetings_)
    {
        meetings.remove(meeting);
    }

    return meetings;
}

Meetings League::getAllMeetings()
{
    auto meetings = getPlayedMeetings();

    for (auto& meeting : getMeetingsToPlay())
    {
        meetings.add(meeting);
    }

    return meetings;
}
