#include "meeting.hpp"

std::ostream& operator<<(std::ostream& os, const Meeting& meeting)
{
    os << meeting.hosting << "-" << meeting.visiting << ":" << meeting.hosting_result << "-" << meeting.visiting_result;
    return os;
}

bool operator<(const Meeting& lhs, const Meeting& rhs)
{
    return (lhs.hosting < rhs.hosting) || (lhs.hosting == rhs.hosting && lhs.visiting < rhs.visiting);
}

Meeting::Meeting(const Team& hosting, const Team& visiting)
    : hosting(hosting), visiting(visiting), hosting_result(0), visiting_result(0), played(false)
{
}

Meeting::Meeting(const Team& hosting, int hosting_result, const Team& visiting, int visiting_result)
    : hosting(hosting), visiting(visiting), hosting_result(hosting_result), visiting_result(visiting_result), played(true)
{
}

void Meetings::add(const Meeting& meeting)
{
    meetings_.insert(meeting);
}

void Meetings::remove(const Meeting& meeting)
{
    meetings_.erase(meeting);
}

std::ostream& operator<<(std::ostream& os, const Meetings& meetings)
{
    for (auto& meeting : meetings.meetings_)
    {
        os << meeting << "\n";
    }
    return os;
}