#ifndef MEETING_HPP
#define MEETING_HPP

#include <iostream>
#include <vector>
#include <set>

#include "team.hpp"

struct Meeting
{
    Meeting(const Team& hosting, const Team& visiting);
    Meeting(const Team& hosting, int hosting_result, const Team& visiting, int visiting_result);

    const Team hosting;
    const Team visiting;
    const int hosting_result = 0;
    const int visiting_result = 0;
    const bool played = false;
};

std::ostream& operator<<(std::ostream&, const Meeting&);

bool operator<(const Meeting&, const Meeting&);

class Meetings
{
    friend std::ostream& operator<<(std::ostream& os, const Meetings& meetings);

public:
    void add(const Meeting&);
    void remove(const Meeting&);

    auto begin() const { return meetings_.begin(); }
    auto end() const { return meetings_.end(); }

private:
    std::set<Meeting> meetings_;
};

#endif // MEETING_HPP
