#ifndef TEAM_HPP
#define TEAM_HPP

#include <string>
#include <vector>
#include <iostream>

class Team
{
    friend std::ostream& operator<<(std::ostream&, const Team&);
    friend bool operator< (const Team&, const Team&);
    friend bool operator==(const Team&, const Team&);

public:
    Team(const std::string& name);

private:
    std::string name_;
};

class Teams
{
    friend std::ostream& operator<<(std::ostream&, const Teams&);

public:
    void add(const Team&);

    auto begin() const { return teams_.begin(); }
    auto end() const { return teams_.end(); }

private:
    std::vector<Team> teams_;
};

#endif // TEAM_HPP
